unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, ExtCtrls, StdCtrls, SysUtils, FileUtil, Forms, Controls, Graphics,
  Dialogs, TAGraph, TAIntervalSources, TASeries, TASources;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    ComboBox1: TComboBox;
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    ListChartSource1: TListChartSource;
    Panel1: TPanel;
    procedure ComboBox1Select(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ Hilfsprozedur für Aufnahme der Zeit-Labels in eine ListChartSource
  Passt auch gut in eine Chart-Utilities Unit... }

procedure PopulateTimeSource(ASource: TListChartSource;
  AStartTime, AEndTime, ADelta: TDateTime; AFormat: String);
var
  t: TDateTime;
begin
  ASource.Clear;
  t := AStartTime;
  while t <= AEndTime do begin
    ASource.Add(t, t, FormatDateTime(AFormat, t));
    t := t + ADelta;
  end;
end;



{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  t: TTime;
  t1, t2, dt: TTime;
begin
  t1 := StrToTime('8:00');
  t2 := StrToTime('21:00');
  dt := StrToTime('1:00');
  t := t1;
  while (t <= t2) do begin
    Chart1LineSeries1.AddXY(t, random);
    t := t + dt;
  end;
  PopulateTimeSource(ListChartSource1, t1, t2, StrToTime('2:00'), 'hh:nn');
end;

procedure TForm1.ComboBox1Select(Sender: TObject);
begin
  case Combobox1.ItemIndex of
    0: Chart1.Bottomaxis.Marks.Source := DateTimeIntervalChartSource1;
    1: Chart1.BottomAxis.Marks.Source := ListChartSource1;
  end;
end;

end.

